Package org.kie.api.builder

## Interface KieBuilder

-     public interface KieBuilder

  KieBuilder is a builder for the resources contained in a KieModule

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static interface` | `KieBuilder.ProjectType` | A marker interace implemented by the different type of projects supported by this KieBuilder

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `KieBuilder` | `buildAll()` | Builds all the KieBases contained in the KieModule for which this KieBuilder has been created
    `KieBuilder` | `buildAll​(java.lang.Class<? extends KieBuilder.ProjectType> projectClass)` | Builds all the KieBases contained in the KieModule for which this KieBuilder has been created creating a project of the type specified by the provided projectClass
    `KieModule` | `getKieModule()` | Returns the KieModule for which this KieBuilder has been created
    `KieModule` | `getKieModule​(java.lang.Class<? extends KieBuilder.ProjectType> projectClass)` | Returns the KieModule for which this KieBuilder has been created of the specific projectClass
    `Results` | `getResults()` | Returns the Results of the building process.
    `KieBuilder` | `setDependencies​(KieModule... dependencies)` | Sets the other KieModules from which the KieModule that has to be built by this KieBuilder depends on
    `KieBuilder` | `setDependencies​(Resource... dependencies)` | Sets the other Resources from which the KieModule that has to be built by this KieBuilder depends on

- - ### Method Detail

    - #### setDependencies

          KieBuilder setDependencies​(KieModule... dependencies)

      Sets the other KieModules from which the KieModule that has to be built by this KieBuilder depends on

    - #### setDependencies

          KieBuilder setDependencies​(Resource... dependencies)

      Sets the other Resources from which the KieModule that has to be built by this KieBuilder depends on

    - #### buildAll

          KieBuilder buildAll()

      Builds all the KieBases contained in the KieModule for which this KieBuilder has been created

    - #### buildAll

          KieBuilder buildAll​(java.lang.Class<? extends KieBuilder.ProjectType> projectClass)

      Builds all the KieBases contained in the KieModule for which this KieBuilder has been created creating a project of the type specified by the provided projectClass

    - #### getResults

          Results getResults()

      Returns the Results of the building process. Invokes `buildAll()` if the KieModule hasn't been built yet

    - #### getKieModule

          KieModule getKieModule()

      Returns the KieModule for which this KieBuilder has been created

    - #### getKieModule

          KieModule getKieModule​(java.lang.Class<? extends KieBuilder.ProjectType> projectClass)

      Returns the KieModule for which this KieBuilder has been created of the specific projectClass